/**
 * @name array-of-arrays-into-ast
 * @fileoverview Turns an array of arrays of data into a nested tree of plain objects
 * @version 3.0.15
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/array-of-arrays-into-ast/}
 */

var arrayOfArraysIntoAst=(()=>{var ur=Object.create;var H=Object.defineProperty,pr=Object.defineProperties,lr=Object.getOwnPropertyDescriptor,yr=Object.getOwnPropertyDescriptors,hr=Object.getOwnPropertyNames,Ht=Object.getOwnPropertySymbols,gr=Object.getPrototypeOf,Bt=Object.prototype.hasOwnProperty,dr=Object.prototype.propertyIsEnumerable;var Gt=(t,e,r)=>e in t?H(t,e,{enumerable:!0,configurable:!0,writable:!0,value:r}):t[e]=r,_=(t,e)=>{for(var r in e||(e={}))Bt.call(e,r)&&Gt(t,r,e[r]);if(Ht)for(var r of Ht(e))dr.call(e,r)&&Gt(t,r,e[r]);return t},J=(t,e)=>pr(t,yr(e));var I=(t,e)=>()=>(e||t((e={exports:{}}).exports,e),e.exports),br=(t,e)=>{for(var r in e)H(t,r,{get:e[r],enumerable:!0})},Lt=(t,e,r,o)=>{if(e&&typeof e=="object"||typeof e=="function")for(let n of hr(e))!Bt.call(t,n)&&n!==r&&H(t,n,{get:()=>e[n],enumerable:!(o=lr(e,n))||o.enumerable});return t};var k=(t,e,r)=>(r=t!=null?ur(gr(t)):{},Lt(e||!t||!t.__esModule?H(r,"default",{value:t,enumerable:!0}):r,t)),_r=t=>Lt(H({},"__esModule",{value:!0}),t);var Me=I((G,$)=>{var mr=200,ee="__lodash_hash_undefined__",re=9007199254740991,gt="[object Arguments]",Or="[object Array]",ne="[object Boolean]",oe="[object Date]",jr="[object Error]",dt="[object Function]",ie="[object GeneratorFunction]",q="[object Map]",ae="[object Number]",bt="[object Object]",Vt="[object Promise]",se="[object RegExp]",X="[object Set]",ce="[object String]",fe="[object Symbol]",ft="[object WeakMap]",ue="[object ArrayBuffer]",Y="[object DataView]",pe="[object Float32Array]",le="[object Float64Array]",ye="[object Int8Array]",he="[object Int16Array]",ge="[object Int32Array]",de="[object Uint8Array]",be="[object Uint8ClampedArray]",_e="[object Uint16Array]",me="[object Uint32Array]",vr=/[\\^$.*+?()[\]{}|]/g,Ar=/\w*$/,Sr=/^\[object .+?Constructor\]$/,xr=/^(?:0|[1-9]\d*)$/,h={};h[gt]=h[Or]=h[ue]=h[Y]=h[ne]=h[oe]=h[pe]=h[le]=h[ye]=h[he]=h[ge]=h[q]=h[ae]=h[bt]=h[se]=h[X]=h[ce]=h[fe]=h[de]=h[be]=h[_e]=h[me]=!0;h[jr]=h[dt]=h[ft]=!1;var wr=typeof global=="object"&&global&&global.Object===Object&&global,kr=typeof self=="object"&&self&&self.Object===Object&&self,v=wr||kr||Function("return this")(),Oe=typeof G=="object"&&G&&!G.nodeType&&G,Ut=Oe&&typeof $=="object"&&$&&!$.nodeType&&$,Tr=Ut&&Ut.exports===Oe;function Er(t,e){return t.set(e[0],e[1]),t}function Cr(t,e){return t.add(e),t}function Mr(t,e){for(var r=-1,o=t?t.length:0;++r<o&&e(t[r],r,t)!==!1;);return t}function Ir(t,e){for(var r=-1,o=e.length,n=t.length;++r<o;)t[n+r]=e[r];return t}function je(t,e,r,o){var n=-1,c=t?t.length:0;for(o&&c&&(r=t[++n]);++n<c;)r=e(r,t[n],n,t);return r}function $r(t,e){for(var r=-1,o=Array(t);++r<t;)o[r]=e(r);return o}function Pr(t,e){return t==null?void 0:t[e]}function ve(t){var e=!1;if(t!=null&&typeof t.toString!="function")try{e=!!(t+"")}catch(r){}return e}function Wt(t){var e=-1,r=Array(t.size);return t.forEach(function(o,n){r[++e]=[n,o]}),r}function _t(t,e){return function(r){return t(e(r))}}function Jt(t){var e=-1,r=Array(t.size);return t.forEach(function(o){r[++e]=o}),r}var Fr=Array.prototype,Nr=Function.prototype,Z=Object.prototype,ct=v["__core-js_shared__"],qt=function(){var t=/[^.]+$/.exec(ct&&ct.keys&&ct.keys.IE_PROTO||"");return t?"Symbol(src)_1."+t:""}(),Ae=Nr.toString,S=Z.hasOwnProperty,Q=Z.toString,Kr=RegExp("^"+Ae.call(S).replace(vr,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$"),Xt=Tr?v.Buffer:void 0,Yt=v.Symbol,Zt=v.Uint8Array,Dr=_t(Object.getPrototypeOf,Object),Rr=Object.create,Hr=Z.propertyIsEnumerable,Gr=Fr.splice,Qt=Object.getOwnPropertySymbols,Br=Xt?Xt.isBuffer:void 0,Lr=_t(Object.keys,Object),ut=N(v,"DataView"),B=N(v,"Map"),pt=N(v,"Promise"),lt=N(v,"Set"),yt=N(v,"WeakMap"),L=N(Object,"create"),Vr=C(ut),Ur=C(B),Wr=C(pt),Jr=C(lt),qr=C(yt),zt=Yt?Yt.prototype:void 0,te=zt?zt.valueOf:void 0;function E(t){var e=-1,r=t?t.length:0;for(this.clear();++e<r;){var o=t[e];this.set(o[0],o[1])}}function Xr(){this.__data__=L?L(null):{}}function Yr(t){return this.has(t)&&delete this.__data__[t]}function Zr(t){var e=this.__data__;if(L){var r=e[t];return r===ee?void 0:r}return S.call(e,t)?e[t]:void 0}function Qr(t){var e=this.__data__;return L?e[t]!==void 0:S.call(e,t)}function zr(t,e){var r=this.__data__;return r[t]=L&&e===void 0?ee:e,this}E.prototype.clear=Xr;E.prototype.delete=Yr;E.prototype.get=Zr;E.prototype.has=Qr;E.prototype.set=zr;function A(t){var e=-1,r=t?t.length:0;for(this.clear();++e<r;){var o=t[e];this.set(o[0],o[1])}}function tn(){this.__data__=[]}function en(t){var e=this.__data__,r=z(e,t);if(r<0)return!1;var o=e.length-1;return r==o?e.pop():Gr.call(e,r,1),!0}function rn(t){var e=this.__data__,r=z(e,t);return r<0?void 0:e[r][1]}function nn(t){return z(this.__data__,t)>-1}function on(t,e){var r=this.__data__,o=z(r,t);return o<0?r.push([t,e]):r[o][1]=e,this}A.prototype.clear=tn;A.prototype.delete=en;A.prototype.get=rn;A.prototype.has=nn;A.prototype.set=on;function P(t){var e=-1,r=t?t.length:0;for(this.clear();++e<r;){var o=t[e];this.set(o[0],o[1])}}function an(){this.__data__={hash:new E,map:new(B||A),string:new E}}function sn(t){return tt(this,t).delete(t)}function cn(t){return tt(this,t).get(t)}function fn(t){return tt(this,t).has(t)}function un(t,e){return tt(this,t).set(t,e),this}P.prototype.clear=an;P.prototype.delete=sn;P.prototype.get=cn;P.prototype.has=fn;P.prototype.set=un;function F(t){this.__data__=new A(t)}function pn(){this.__data__=new A}function ln(t){return this.__data__.delete(t)}function yn(t){return this.__data__.get(t)}function hn(t){return this.__data__.has(t)}function gn(t,e){var r=this.__data__;if(r instanceof A){var o=r.__data__;if(!B||o.length<mr-1)return o.push([t,e]),this;r=this.__data__=new P(o)}return r.set(t,e),this}F.prototype.clear=pn;F.prototype.delete=ln;F.prototype.get=yn;F.prototype.has=hn;F.prototype.set=gn;function dn(t,e){var r=Ot(t)||Hn(t)?$r(t.length,String):[],o=r.length,n=!!o;for(var c in t)(e||S.call(t,c))&&!(n&&(c=="length"||Nn(c,o)))&&r.push(c);return r}function Se(t,e,r){var o=t[e];(!(S.call(t,e)&&Te(o,r))||r===void 0&&!(e in t))&&(t[e]=r)}function z(t,e){for(var r=t.length;r--;)if(Te(t[r][0],e))return r;return-1}function bn(t,e){return t&&xe(e,jt(e),t)}function ht(t,e,r,o,n,c,i){var a;if(o&&(a=c?o(t,n,c,i):o(t)),a!==void 0)return a;if(!et(t))return t;var u=Ot(t);if(u){if(a=$n(t),!e)return Cn(t,a)}else{var p=T(t),d=p==dt||p==ie;if(Bn(t))return An(t,e);if(p==bt||p==gt||d&&!c){if(ve(t))return c?t:{};if(a=Pn(d?{}:t),!e)return Mn(t,bn(a,t))}else{if(!h[p])return c?t:{};a=Fn(t,p,ht,e)}}i||(i=new F);var m=i.get(t);if(m)return m;if(i.set(t,a),!u)var l=r?In(t):jt(t);return Mr(l||t,function(s,g){l&&(g=s,s=t[g]),Se(a,g,ht(s,e,r,o,g,t,i))}),a}function _n(t){return et(t)?Rr(t):{}}function mn(t,e,r){var o=e(t);return Ot(t)?o:Ir(o,r(t))}function On(t){return Q.call(t)}function jn(t){if(!et(t)||Dn(t))return!1;var e=Ce(t)||ve(t)?Kr:Sr;return e.test(C(t))}function vn(t){if(!ke(t))return Lr(t);var e=[];for(var r in Object(t))S.call(t,r)&&r!="constructor"&&e.push(r);return e}function An(t,e){if(e)return t.slice();var r=new t.constructor(t.length);return t.copy(r),r}function mt(t){var e=new t.constructor(t.byteLength);return new Zt(e).set(new Zt(t)),e}function Sn(t,e){var r=e?mt(t.buffer):t.buffer;return new t.constructor(r,t.byteOffset,t.byteLength)}function xn(t,e,r){var o=e?r(Wt(t),!0):Wt(t);return je(o,Er,new t.constructor)}function wn(t){var e=new t.constructor(t.source,Ar.exec(t));return e.lastIndex=t.lastIndex,e}function kn(t,e,r){var o=e?r(Jt(t),!0):Jt(t);return je(o,Cr,new t.constructor)}function Tn(t){return te?Object(te.call(t)):{}}function En(t,e){var r=e?mt(t.buffer):t.buffer;return new t.constructor(r,t.byteOffset,t.length)}function Cn(t,e){var r=-1,o=t.length;for(e||(e=Array(o));++r<o;)e[r]=t[r];return e}function xe(t,e,r,o){r||(r={});for(var n=-1,c=e.length;++n<c;){var i=e[n],a=o?o(r[i],t[i],i,r,t):void 0;Se(r,i,a===void 0?t[i]:a)}return r}function Mn(t,e){return xe(t,we(t),e)}function In(t){return mn(t,jt,we)}function tt(t,e){var r=t.__data__;return Kn(e)?r[typeof e=="string"?"string":"hash"]:r.map}function N(t,e){var r=Pr(t,e);return jn(r)?r:void 0}var we=Qt?_t(Qt,Object):Un,T=On;(ut&&T(new ut(new ArrayBuffer(1)))!=Y||B&&T(new B)!=q||pt&&T(pt.resolve())!=Vt||lt&&T(new lt)!=X||yt&&T(new yt)!=ft)&&(T=function(t){var e=Q.call(t),r=e==bt?t.constructor:void 0,o=r?C(r):void 0;if(o)switch(o){case Vr:return Y;case Ur:return q;case Wr:return Vt;case Jr:return X;case qr:return ft}return e});function $n(t){var e=t.length,r=t.constructor(e);return e&&typeof t[0]=="string"&&S.call(t,"index")&&(r.index=t.index,r.input=t.input),r}function Pn(t){return typeof t.constructor=="function"&&!ke(t)?_n(Dr(t)):{}}function Fn(t,e,r,o){var n=t.constructor;switch(e){case ue:return mt(t);case ne:case oe:return new n(+t);case Y:return Sn(t,o);case pe:case le:case ye:case he:case ge:case de:case be:case _e:case me:return En(t,o);case q:return xn(t,o,r);case ae:case ce:return new n(t);case se:return wn(t);case X:return kn(t,o,r);case fe:return Tn(t)}}function Nn(t,e){return e=e==null?re:e,!!e&&(typeof t=="number"||xr.test(t))&&t>-1&&t%1==0&&t<e}function Kn(t){var e=typeof t;return e=="string"||e=="number"||e=="symbol"||e=="boolean"?t!=="__proto__":t===null}function Dn(t){return!!qt&&qt in t}function ke(t){var e=t&&t.constructor,r=typeof e=="function"&&e.prototype||Z;return t===r}function C(t){if(t!=null){try{return Ae.call(t)}catch(e){}try{return t+""}catch(e){}}return""}function Rn(t){return ht(t,!0,!0)}function Te(t,e){return t===e||t!==t&&e!==e}function Hn(t){return Gn(t)&&S.call(t,"callee")&&(!Hr.call(t,"callee")||Q.call(t)==gt)}var Ot=Array.isArray;function Ee(t){return t!=null&&Ln(t.length)&&!Ce(t)}function Gn(t){return Vn(t)&&Ee(t)}var Bn=Br||Wn;function Ce(t){var e=et(t)?Q.call(t):"";return e==dt||e==ie}function Ln(t){return typeof t=="number"&&t>-1&&t%1==0&&t<=re}function et(t){var e=typeof t;return!!t&&(e=="object"||e=="function")}function Vn(t){return!!t&&typeof t=="object"}function jt(t){return Ee(t)?dn(t):vn(t)}function Un(){return[]}function Wn(){return!1}$.exports=Rn});var Ke=I((fa,Ne)=>{var Ie=1/0,Pe=9007199254740991,Jn=17976931348623157e292,$e=0/0,qn="[object Arguments]",Xn="[object Function]",Yn="[object GeneratorFunction]",Zn="[object String]",Qn="[object Symbol]",zn=/^\s+|\s+$/g,to=/^[-+]0x[0-9a-f]+$/i,eo=/^0b[01]+$/i,ro=/^0o[0-7]+$/i,no=/^(?:0|[1-9]\d*)$/,oo=parseInt;function io(t,e){for(var r=-1,o=t?t.length:0,n=Array(o);++r<o;)n[r]=e(t[r],r,t);return n}function ao(t,e,r,o){for(var n=t.length,c=r+(o?1:-1);o?c--:++c<n;)if(e(t[c],c,t))return c;return-1}function so(t,e,r){if(e!==e)return ao(t,co,r);for(var o=r-1,n=t.length;++o<n;)if(t[o]===e)return o;return-1}function co(t){return t!==t}function fo(t,e){for(var r=-1,o=Array(t);++r<t;)o[r]=e(r);return o}function uo(t,e){return io(e,function(r){return t[r]})}function po(t,e){return function(r){return t(e(r))}}var rt=Object.prototype,At=rt.hasOwnProperty,nt=rt.toString,lo=rt.propertyIsEnumerable,yo=po(Object.keys,Object),ho=Math.max;function go(t,e){var r=Fe(t)||jo(t)?fo(t.length,String):[],o=r.length,n=!!o;for(var c in t)(e||At.call(t,c))&&!(n&&(c=="length"||_o(c,o)))&&r.push(c);return r}function bo(t){if(!mo(t))return yo(t);var e=[];for(var r in Object(t))At.call(t,r)&&r!="constructor"&&e.push(r);return e}function _o(t,e){return e=e==null?Pe:e,!!e&&(typeof t=="number"||no.test(t))&&t>-1&&t%1==0&&t<e}function mo(t){var e=t&&t.constructor,r=typeof e=="function"&&e.prototype||rt;return t===r}function Oo(t,e,r,o){t=St(t)?t:Mo(t),r=r&&!o?To(r):0;var n=t.length;return r<0&&(r=ho(n+r,0)),xo(t)?r<=n&&t.indexOf(e,r)>-1:!!n&&so(t,e,r)>-1}function jo(t){return vo(t)&&At.call(t,"callee")&&(!lo.call(t,"callee")||nt.call(t)==qn)}var Fe=Array.isArray;function St(t){return t!=null&&So(t.length)&&!Ao(t)}function vo(t){return xt(t)&&St(t)}function Ao(t){var e=vt(t)?nt.call(t):"";return e==Xn||e==Yn}function So(t){return typeof t=="number"&&t>-1&&t%1==0&&t<=Pe}function vt(t){var e=typeof t;return!!t&&(e=="object"||e=="function")}function xt(t){return!!t&&typeof t=="object"}function xo(t){return typeof t=="string"||!Fe(t)&&xt(t)&&nt.call(t)==Zn}function wo(t){return typeof t=="symbol"||xt(t)&&nt.call(t)==Qn}function ko(t){if(!t)return t===0?t:0;if(t=Eo(t),t===Ie||t===-Ie){var e=t<0?-1:1;return e*Jn}return t===t?t:0}function To(t){var e=ko(t),r=e%1;return e===e?r?e-r:e:0}function Eo(t){if(typeof t=="number")return t;if(wo(t))return $e;if(vt(t)){var e=typeof t.valueOf=="function"?t.valueOf():t;t=vt(e)?e+"":e}if(typeof t!="string")return t===0?t:+t;t=t.replace(zn,"");var r=eo.test(t);return r||ro.test(t)?oo(t.slice(2),r?2:8):to.test(t)?$e:+t}function Co(t){return St(t)?go(t):bo(t)}function Mo(t){return t?uo(t,Co(t)):[]}Ne.exports=Oo});var Ve=I((ua,Le)=>{var Io=200,Tt="__lodash_hash_undefined__",$o=1/0,Po="[object Function]",Fo="[object GeneratorFunction]",No=/[\\^$.*+?()[\]{}|]/g,Ko=/^\[object .+?Constructor\]$/,Do=typeof global=="object"&&global&&global.Object===Object&&global,Ro=typeof self=="object"&&self&&self.Object===Object&&self,Et=Do||Ro||Function("return this")();function Ho(t,e){var r=t?t.length:0;return!!r&&Lo(t,e,0)>-1}function Go(t,e,r){for(var o=-1,n=t?t.length:0;++o<n;)if(r(e,t[o]))return!0;return!1}function Bo(t,e,r,o){for(var n=t.length,c=r+(o?1:-1);o?c--:++c<n;)if(e(t[c],c,t))return c;return-1}function Lo(t,e,r){if(e!==e)return Bo(t,Vo,r);for(var o=r-1,n=t.length;++o<n;)if(t[o]===e)return o;return-1}function Vo(t){return t!==t}function Uo(t,e){return t.has(e)}function Wo(t,e){return t==null?void 0:t[e]}function Jo(t){var e=!1;if(t!=null&&typeof t.toString!="function")try{e=!!(t+"")}catch(r){}return e}function Re(t){var e=-1,r=Array(t.size);return t.forEach(function(o){r[++e]=o}),r}var qo=Array.prototype,Xo=Function.prototype,He=Object.prototype,wt=Et["__core-js_shared__"],De=function(){var t=/[^.]+$/.exec(wt&&wt.keys&&wt.keys.IE_PROTO||"");return t?"Symbol(src)_1."+t:""}(),Ge=Xo.toString,Ct=He.hasOwnProperty,Yo=He.toString,Zo=RegExp("^"+Ge.call(Ct).replace(No,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$"),Qo=qo.splice,zo=Mt(Et,"Map"),kt=Mt(Et,"Set"),V=Mt(Object,"create");function M(t){var e=-1,r=t?t.length:0;for(this.clear();++e<r;){var o=t[e];this.set(o[0],o[1])}}function ti(){this.__data__=V?V(null):{}}function ei(t){return this.has(t)&&delete this.__data__[t]}function ri(t){var e=this.__data__;if(V){var r=e[t];return r===Tt?void 0:r}return Ct.call(e,t)?e[t]:void 0}function ni(t){var e=this.__data__;return V?e[t]!==void 0:Ct.call(e,t)}function oi(t,e){var r=this.__data__;return r[t]=V&&e===void 0?Tt:e,this}M.prototype.clear=ti;M.prototype.delete=ei;M.prototype.get=ri;M.prototype.has=ni;M.prototype.set=oi;function K(t){var e=-1,r=t?t.length:0;for(this.clear();++e<r;){var o=t[e];this.set(o[0],o[1])}}function ii(){this.__data__=[]}function ai(t){var e=this.__data__,r=it(e,t);if(r<0)return!1;var o=e.length-1;return r==o?e.pop():Qo.call(e,r,1),!0}function si(t){var e=this.__data__,r=it(e,t);return r<0?void 0:e[r][1]}function ci(t){return it(this.__data__,t)>-1}function fi(t,e){var r=this.__data__,o=it(r,t);return o<0?r.push([t,e]):r[o][1]=e,this}K.prototype.clear=ii;K.prototype.delete=ai;K.prototype.get=si;K.prototype.has=ci;K.prototype.set=fi;function D(t){var e=-1,r=t?t.length:0;for(this.clear();++e<r;){var o=t[e];this.set(o[0],o[1])}}function ui(){this.__data__={hash:new M,map:new(zo||K),string:new M}}function pi(t){return at(this,t).delete(t)}function li(t){return at(this,t).get(t)}function yi(t){return at(this,t).has(t)}function hi(t,e){return at(this,t).set(t,e),this}D.prototype.clear=ui;D.prototype.delete=pi;D.prototype.get=li;D.prototype.has=yi;D.prototype.set=hi;function ot(t){var e=-1,r=t?t.length:0;for(this.__data__=new D;++e<r;)this.add(t[e])}function gi(t){return this.__data__.set(t,Tt),this}function di(t){return this.__data__.has(t)}ot.prototype.add=ot.prototype.push=gi;ot.prototype.has=di;function it(t,e){for(var r=t.length;r--;)if(Si(t[r][0],e))return r;return-1}function bi(t){if(!Be(t)||ji(t))return!1;var e=xi(t)||Jo(t)?Zo:Ko;return e.test(vi(t))}function _i(t,e,r){var o=-1,n=Ho,c=t.length,i=!0,a=[],u=a;if(r)i=!1,n=Go;else if(c>=Io){var p=e?null:mi(t);if(p)return Re(p);i=!1,n=Uo,u=new ot}else u=e?[]:a;t:for(;++o<c;){var d=t[o],m=e?e(d):d;if(d=r||d!==0?d:0,i&&m===m){for(var l=u.length;l--;)if(u[l]===m)continue t;e&&u.push(m),a.push(d)}else n(u,m,r)||(u!==a&&u.push(m),a.push(d))}return a}var mi=kt&&1/Re(new kt([,-0]))[1]==$o?function(t){return new kt(t)}:wi;function at(t,e){var r=t.__data__;return Oi(e)?r[typeof e=="string"?"string":"hash"]:r.map}function Mt(t,e){var r=Wo(t,e);return bi(r)?r:void 0}function Oi(t){var e=typeof t;return e=="string"||e=="number"||e=="symbol"||e=="boolean"?t!=="__proto__":t===null}function ji(t){return!!De&&De in t}function vi(t){if(t!=null){try{return Ge.call(t)}catch(e){}try{return t+""}catch(e){}}return""}function Ai(t){return t&&t.length?_i(t):[]}function Si(t,e){return t===e||t!==t&&e!==e}function xi(t){var e=Be(t)?Yo.call(t):"";return e==Po||e==Fo}function Be(t){var e=typeof t;return!!t&&(e=="object"||e=="function")}function wi(){}Le.exports=Ai});var It=I((pa,Je)=>{var ki="[object Object]";function Ti(t){var e=!1;if(t!=null&&typeof t.toString!="function")try{e=!!(t+"")}catch(r){}return e}function Ei(t,e){return function(r){return t(e(r))}}var Ci=Function.prototype,Ue=Object.prototype,We=Ci.toString,Mi=Ue.hasOwnProperty,Ii=We.call(Object),$i=Ue.toString,Pi=Ei(Object.getPrototypeOf,Object);function Fi(t){return!!t&&typeof t=="object"}function Ni(t){if(!Fi(t)||$i.call(t)!=ki||Ti(t))return!1;var e=Pi(t);if(e===null)return!0;var r=Mi.call(e,"constructor")&&e.constructor;return typeof r=="function"&&r instanceof r&&We.call(r)==Ii}Je.exports=Ni});var ze=I((U,R)=>{var Ki="[object Date]",Di=typeof global=="object"&&global&&global.Object===Object&&global,Qe=typeof U=="object"&&U&&!U.nodeType&&U,qe=Qe&&typeof R=="object"&&R&&!R.nodeType&&R,Ri=qe&&qe.exports===Qe,Xe=Ri&&Di.process,Ye=function(){try{return Xe&&Xe.binding("util")}catch(t){}}(),Ze=Ye&&Ye.isDate;function Hi(t){return function(e){return t(e)}}var Gi=Object.prototype,Bi=Gi.toString;function Li(t){return Ui(t)&&Bi.call(t)==Ki}var Vi=Ze?Hi(Ze):Li;function Ui(t){return!!t&&typeof t=="object"}R.exports=Vi});var er=I((la,tr)=>{var Wi=typeof global=="object"&&global&&global.Object===Object&&global,Ji=typeof self=="object"&&self&&self.Object===Object&&self,qi=Wi||Ji||Function("return this")(),Xi=qi.isFinite;function Yi(t){return typeof t=="number"&&Xi(t)}tr.exports=Yi});var sa={};br(sa,{defaults:()=>fr,generateAst:()=>aa,version:()=>oa});var f=k(Me(),1),ir=k(Ke(),1),ar=k(Ve(),1),j=k(It(),1),W=k(ze(),1),Dt=k(er(),1);var rr=k(It(),1);function O(t){return t==null?!1:Array.isArray(t)||typeof t=="string"?!!t.length:(0,rr.default)(t)?!!Object.keys(t).length:typeof t=="number"}function $t(t){if(typeof t!="string")throw new TypeError("Expected a string");return t.replace(/[|\\{}()[\]^$+*?.]/g,"\\$&").replace(/-/g,"\\x2d")}var Pt=new Map,nr=(t,e)=>{if(!Array.isArray(t))switch(typeof t){case"string":t=[t];break;case"undefined":t=[];break;default:throw new TypeError(`Expected '${e}' to be a string or an array, but got a type of '${typeof t}'`)}return t.filter(r=>{if(typeof r!="string"){if(typeof r>"u")return!1;throw new TypeError(`Expected '${e}' to be an array of strings, but found a type of '${typeof r}' in the array`)}return!0})},Zi=(t,e)=>{e=_({caseSensitive:!1},e);let r=t+JSON.stringify(e);if(Pt.has(r))return Pt.get(r);let o=t[0]==="!";o&&(t=t.slice(1)),t=$t(t).replace(/\\\*/g,"[\\s\\S]*");let n=new RegExp(`^${t}$`,e.caseSensitive?"":"i");return n.negated=o,Pt.set(r,n),n},Qi=(t,e,r,o)=>{if(t=nr(t,"inputs"),e=nr(e,"patterns"),e.length===0)return[];e=e.map(i=>Zi(i,r));let{allPatterns:n}=r||{},c=[];for(let i of t){let a,u=[...e].fill(!1);for(let[p,d]of e.entries())if(d.test(i)&&(u[p]=!0,a=!d.negated,!a))break;if(!(a===!1||a===void 0&&e.some(p=>!p.negated)||n&&u.some((p,d)=>!p&&!e[d].negated))&&(c.push(i),o))break}return c};function st(t,e,r){return Qi(t,e,r,!0).length>0}var zi={arrayVsArrayAllMustBeFound:"any",caseSensitive:!0};function Ft(t,e,r){if(!t.length||!e.length)return!1;let o=_(_({},zi),r),n=typeof t=="string"?[t]:Array.from(t);return typeof e=="string"?n.some(c=>st(c,e,{caseSensitive:o.caseSensitive})):o.arrayVsArrayAllMustBeFound==="any"?e.some(c=>n.some(i=>st(i,c,{caseSensitive:o.caseSensitive}))):e.every(c=>n.some(i=>st(i,c,{caseSensitive:o.caseSensitive})))}function Nt(t){return typeof t=="string"}function ta(t){return typeof t=="number"}function Kt(t){return typeof t=="boolean"}var x=Array.isArray;function or(t){return!!t&&t.some(e=>typeof e=="string")}function ea(t,e){return Object.keys(t).length===0||Object.keys(e).length===0||Object.keys(t).every(r=>Object.keys(e).includes(r))||Object.keys(e).every(r=>Object.keys(t).includes(r))}function b(t){return t===null?"null":(0,W.default)(t)?"date":(0,j.default)(t)?"object":x(t)?"array":typeof t}var ra={cb:null,mergeObjectsOnlyWhenKeysetMatches:!0,ignoreKeys:[],hardMergeKeys:[],hardArrayConcatKeys:[],mergeArraysContainingStringsToBeEmpty:!1,oneToManyArrayObjectMerge:!1,hardMergeEverything:!1,hardArrayConcat:!1,ignoreEverything:!1,concatInsteadOfMerging:!0,dedupeStringsInArrayValues:!1,mergeBoolsUsingOrNotAnd:!0,useNullAsExplicitFalse:!1};function w(t,e,r,o){var m;let n=_(_({},ra),o);typeof n.ignoreKeys=="string"&&(n.ignoreKeys=[n.ignoreKeys]),typeof n.hardMergeKeys=="string"&&(n.hardMergeKeys=[n.hardMergeKeys]),n.hardMergeKeys.includes("*")&&(n.hardMergeEverything=!0),n.ignoreKeys.includes("*")&&(n.ignoreEverything=!0);let c;if(n.useNullAsExplicitFalse&&(e===null||r===null))return typeof n.cb=="function"?n.cb(e,r,null,{path:t.path,key:t.key,type:t.type}):null;let i=x(e)||(0,j.default)(e)?(0,f.default)(e):e,a=x(r)||(0,j.default)(r)?(0,f.default)(r):r,u;n.ignoreEverything?u=i:n.hardMergeEverything&&(u=a);let p=n.hardMergeEverything||n.ignoreEverything;if(x(i))if(O(i))if(x(a)&&O(a)){if(n.mergeArraysContainingStringsToBeEmpty&&(or(i)||or(a))){let s=p?u:[];return typeof n.cb=="function"?n.cb((0,f.default)(e),(0,f.default)(r),s,{path:c,key:t.key,type:t.type}):s}if(n.hardArrayConcat){let s=p?u:i.concat(a);return typeof n.cb=="function"?n.cb((0,f.default)(e),(0,f.default)(r),s,{path:c,key:t.key,type:t.type}):s}let l=[];for(let s=0,g=Math.max(i.length,a.length);s<g;s++)c=(m=t.path)!=null&&m.length?`${t.path}.${s}`:`${s}`,(0,j.default)(i[s])&&(0,j.default)(a[s])&&(n.mergeObjectsOnlyWhenKeysetMatches&&ea(i[s],a[s])||!n.mergeObjectsOnlyWhenKeysetMatches)?l.push(w({path:c,key:t.key,type:[b(i),b(a)]},i[s],a[s],n)):n.oneToManyArrayObjectMerge&&(i.length===1||a.length===1)?l.push(i.length===1?w({path:c,key:t.key,type:[b(i),b(a)]},i[0],a[s],n):w({path:c,key:t.key,type:[b(i),b(a)]},i[s],a[0],n)):n.concatInsteadOfMerging?(s<i.length&&l.push(i[s]),s<a.length&&l.push(a[s])):(s<i.length&&l.push(i[s]),s<a.length&&!(0,ir.default)(i,a[s])&&l.push(a[s]));n.dedupeStringsInArrayValues&&l.every(s=>Nt(s))&&(l=(0,ar.default)(l).sort()),i=(0,f.default)(l)}else{let l=p?u:i;return typeof n.cb=="function"?n.cb((0,f.default)(e),(0,f.default)(r),l,{path:c,key:t.key,type:t.type}):l}else{if(O(a)){let s=p?u:a;return typeof n.cb=="function"?n.cb((0,f.default)(e),(0,f.default)(r),s,{path:c,key:t.key,type:t.type}):s}let l=p?u:i;return typeof n.cb=="function"?n.cb((0,f.default)(e),(0,f.default)(r),l,{path:c,key:t.key,type:t.type}):l}else if((0,j.default)(i)){if(O(i)){if(x(a)){if(O(a)){let y=p?u:a;return typeof n.cb=="function"?n.cb((0,f.default)(e),(0,f.default)(r),y,{path:c,key:t.key,type:t.type}):y}let g=p?u:i;return typeof n.cb=="function"?n.cb((0,f.default)(e),(0,f.default)(r),g,{path:c,key:t.key,type:t.type}):g}if((0,j.default)(a)){Object.keys(a).forEach(y=>{var Rt;c=(Rt=t.path)!=null&&Rt.length?`${t.path}.${y}`:`${y}`,i.hasOwnProperty(y)?Ft(y,n.ignoreKeys)?i[y]=w({path:c,key:y,type:[b(i),b(a)]},i[y],a[y],J(_({},n),{ignoreEverything:!0})):Ft(y,n.hardMergeKeys)?i[y]=w({path:c,key:y,type:[b(i),b(a)]},i[y],a[y],J(_({},n),{hardMergeEverything:!0})):Ft(y,n.hardArrayConcatKeys)?i[y]=w({path:c,key:y,type:[b(i),b(a)]},i[y],a[y],J(_({},n),{hardArrayConcat:!0})):i[y]=w({path:c,key:y,type:[b(i[y]),b(a[y])]},i[y],a[y],n):i[y]=a[y]});let g=p?u:i;return typeof n.cb=="function"?n.cb((0,f.default)(e),(0,f.default)(r),g,{path:t.path,key:t.key,type:t.type}):i}let s=p?u:i;return typeof n.cb=="function"?n.cb((0,f.default)(e),(0,f.default)(r),s,{path:t.path,key:t.key,type:t.type}):s}if(x(a)||(0,j.default)(a)||O(a)){let s=p?u:a;return typeof n.cb=="function"?n.cb((0,f.default)(e),(0,f.default)(r),s,{path:t.path,key:t.key,type:t.type}):s}let l=p?u:i;return typeof n.cb=="function"?n.cb((0,f.default)(e),(0,f.default)(r),l,{path:t.path,key:t.key,type:t.type}):l}else if((0,W.default)(i)){if((0,Dt.default)(+i)){if((0,W.default)(a)){if((0,Dt.default)(+a)){let y=p?u:i>a?i:a;return typeof n.cb=="function"?n.cb((0,f.default)(e),(0,f.default)(r),y,{path:t.path,key:t.key,type:t.type}):y}let g=p?u:i;return typeof n.cb=="function"?n.cb((0,f.default)(e),(0,f.default)(r),g,{path:t.path,key:t.key,type:t.type}):g}let s=p?u:a||i;return typeof n.cb=="function"?n.cb((0,f.default)(e),(0,f.default)(r),s,{path:t.path,key:t.key,type:t.type}):s}if((0,W.default)(a)){let s=p?u:a;return typeof n.cb=="function"?n.cb((0,f.default)(e),(0,f.default)(r),s,{path:t.path,key:t.key,type:t.type}):s}let l=p?u:a;return typeof n.cb=="function"?n.cb((0,f.default)(e),(0,f.default)(r),l,{path:t.path,key:t.key,type:t.type}):l}else if(Nt(i)){if(O(i)){if((x(a)||(0,j.default)(a)||Nt(a))&&O(a)){let g=p?u:a;return typeof n.cb=="function"?n.cb((0,f.default)(e),(0,f.default)(r),g,{path:t.path,key:t.key,type:t.type}):g}let s=p?u:i;return typeof n.cb=="function"?n.cb((0,f.default)(e),(0,f.default)(r),s,{path:t.path,key:t.key,type:t.type}):s}if(a!=null&&!Kt(a)){let s=p?u:a;return typeof n.cb=="function"?n.cb((0,f.default)(e),(0,f.default)(r),s,{path:t.path,key:t.key,type:t.type}):s}let l=p?u:i;return typeof n.cb=="function"?n.cb((0,f.default)(e),(0,f.default)(r),l,{path:t.path,key:t.key,type:t.type}):l}else if(ta(i)){if(O(a)){let s=p?u:a;return typeof n.cb=="function"?n.cb((0,f.default)(e),(0,f.default)(r),s,{path:t.path,key:t.key,type:t.type}):s}let l=p?u:i;return typeof n.cb=="function"?n.cb((0,f.default)(e),(0,f.default)(r),l,{path:t.path,key:t.key,type:t.type}):l}else if(Kt(i)){if(Kt(a)){if(n.mergeBoolsUsingOrNotAnd){let g=p?u:i||a;return typeof n.cb=="function"?n.cb((0,f.default)(e),(0,f.default)(r),g,{path:t.path,key:t.key,type:t.type}):g}let s=p?u:i&&a;return typeof n.cb=="function"?n.cb((0,f.default)(e),(0,f.default)(r),s,{path:t.path,key:t.key,type:t.type}):s}if(a!=null){let s=p?u:a;return typeof n.cb=="function"?n.cb((0,f.default)(e),(0,f.default)(r),s,{path:t.path,key:t.key,type:t.type}):s}let l=p?u:i;return typeof n.cb=="function"?n.cb((0,f.default)(e),(0,f.default)(r),l,{path:t.path,key:t.key,type:t.type}):l}else if(i===null){if(a!=null){let s=p?u:a;return typeof n.cb=="function"?n.cb((0,f.default)(e),(0,f.default)(r),s,{path:t.path,key:t.key,type:t.type}):s}let l=p?u:i;return typeof n.cb=="function"?n.cb((0,f.default)(e),(0,f.default)(r),l,{path:t.path,key:t.key,type:t.type}):l}else{let l=p?u:a;return typeof n.cb=="function"?n.cb((0,f.default)(e),(0,f.default)(r),l,{path:t.path,key:t.key,type:t.type}):l}let d=p?u:i;return typeof n.cb=="function"?n.cb((0,f.default)(e),(0,f.default)(r),d,{path:t.path,key:t.key,type:t.type}):d}function sr(t,e,r){if(!arguments.length)throw new TypeError("object-merge-advanced/mergeAdvanced(): [THROW_ID_01] Both inputs are missing");return w({key:null,path:"",type:[b(t),b(e)]},t,e,r)}var cr="3.0.15";var oa=cr,fr={dedupe:!0};function ia(t){return Object.keys(t).sort().reduce((e,r)=>(e[r]=t[r],e),{})}function aa(t,e){if(Array.isArray(t)){if(t.length===0)return{}}else throw new Error(`array-of-arrays-into-ast: [THROW_ID_01] inputArr must be array. Currently it's of a type ${typeof t} equal to:
${JSON.stringify(t,null,4)}`);let r=_(_({},fr),e),o={};return t.forEach(n=>{let c=null;for(let i=n.length;i--;)c={[n[i]]:[c]};o=sr(o,c,{concatInsteadOfMerging:!r.dedupe})}),ia(o)}return _r(sa);})();
/**
 * @name object-merge-advanced
 * @fileoverview Recursively, deeply merge of anything (objects, arrays, strings or nested thereof), which weighs contents by type hierarchy to ensure the maximum content is retained
 * @version 13.1.0
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/object-merge-advanced/}
 */
/**
 * @name util-nonempty
 * @fileoverview Is the input (plain object, array, string or whatever) not empty?
 * @version 4.0.12
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/util-nonempty/}
 */
